"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AssemblyList = void 0;
const MMAssembly_1 = require("../MM/MMAssembly");
const OOTAssembly_1 = require("../OoT/OOTAssembly");
const Z64LibSupportedGames_1 = require("../Utilities/Z64LibSupportedGames");
class AssemblyList {
    static getAssemblyForGame(game) {
        switch (game) {
            case Z64LibSupportedGames_1.Z64LibSupportedGames.OCARINA_OF_TIME:
                return OOTAssembly_1.OOTAssemblyBuffers;
            case Z64LibSupportedGames_1.Z64LibSupportedGames.MAJORAS_MASK:
                return MMAssembly_1.MMAssemblyBuffers;
        }
        return undefined;
    }
}
exports.AssemblyList = AssemblyList;
//# sourceMappingURL=AssemblyList.js.map