/// <reference types="node" />
export declare enum DisplayOpcodes {
    G_NOOP = 0,
    G_VTX = 1,
    G_MODIFYVTX = 2,
    G_CULLDL = 3,
    G_BRANCH_Z = 4,
    G_TRI1 = 5,
    G_TRI2 = 6,
    G_QUAD = 7,
    G_SPECIAL_3 = 211,
    G_SPECIAL_2 = 212,
    G_SPECIAL_1 = 213,
    G_DMA_IO = 214,
    G_TEXTURE = 215,
    G_POPMTX = 216,
    G_GEOMETRYMODE = 217,
    G_MTX = 218,
    G_MOVEWORD = 219,
    G_MOVEMEM = 220,
    G_LOAD_UCODE = 221,
    G_DL = 222,
    G_ENDDL = 223,
    G_SPNOOP = 224,
    G_RDPHALF_1 = 225,
    G_SETOTHERMODE_L = 226,
    G_SETOTHERMODE_H = 227,
    G_TEXRECT = 228,
    G_TEXRECTFLIP = 229,
    G_RDPLOADSYNC = 230,
    G_RDPPIPESYNC = 231,
    G_RDPTILESYNC = 232,
    G_RDPFULLSYNC = 233,
    G_SETKEYGB = 234,
    G_SETKEYR = 235,
    G_SETCONVERT = 236,
    G_SETSCISSOR = 237,
    G_SETPRIMDEPTH = 238,
    G_RDPSETOTHERMODE = 239,
    G_LOADTLUT = 240,
    G_RDPHALF_2 = 241,
    G_SETTILESIZE = 242,
    G_LOADBLOCK = 243,
    G_LOADTILE = 244,
    G_SETTILE = 245,
    G_FILLRECT = 246,
    G_SETFILLCOLOR = 247,
    G_SETFOGCOLOR = 248,
    G_SETBLENDCOLOR = 249,
    G_SETPRIMCOLOR = 250,
    G_SETENVCOLOR = 251,
    G_SETCOMBINE = 252,
    G_SETTIMG = 253,
    G_SETZIMG = 254,
    G_SETCIMG = 255
}
export declare class zzstatic2 {
    pointerSet: Set<number>;
    pointerList: Array<number>;
    displayListStarts: Set<number>;
    temp: Buffer;
    recurseSet: Set<number>;
    isValidOpCode(op: number): boolean;
    isOpCodeEnd(op: DisplayOpcodes): boolean;
    isOpCodeNOP(op: DisplayOpcodes): boolean;
    doesOpCodeHavePointer(op: DisplayOpcodes): boolean;
    readCommand(buf: Buffer, offset: number): Command;
    readPointer(buf: Buffer, offset: number): number;
    findAllDisplayLists(buf: Buffer): Set<number>;
    scanList(buf: Buffer, start: number): void;
    repoint(buf: Buffer, base: number): void;
}
declare class Command {
    id: number;
    params: number;
    constructor(id: number, params: number);
    equals(cmd: Command): boolean;
    toString(): string;
}
export {};
//# sourceMappingURL=zzstatic2.d.ts.map