"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShieldsEquipment = void 0;
const Z64API = __importStar(require("../../API/imports"));
const Z64CORE = __importStar(require("../importsZ64"));
const JSONTemplate_1 = require("modloader64_api/JSONTemplate");
class ShieldsEquipment extends JSONTemplate_1.JSONTemplate {
    emulator;
    jsonFields = ['dekuShield', 'hylianShield', 'mirrorShield', 'shieldLevel'];
    constructor(emulator) {
        super();
        this.emulator = emulator;
    }
    set dekuShield(bool) {
        this.emulator.rdramWriteBit8(Z64CORE.Z64.Z64_EQUIP_ADDR + 1, 3 /* ShieldBitMap.DEKU */, bool);
    }
    get dekuShield() {
        return this.emulator.rdramReadBit8(Z64CORE.Z64.Z64_EQUIP_ADDR + 1, 3 /* ShieldBitMap.DEKU */);
    }
    set hylianShield(bool) {
        this.emulator.rdramWriteBit8(Z64CORE.Z64.Z64_EQUIP_ADDR + 1, 2 /* ShieldBitMap.HYLIAN */, bool);
    }
    get hylianShield() {
        return this.emulator.rdramReadBit8(Z64CORE.Z64.Z64_EQUIP_ADDR + 1, 2 /* ShieldBitMap.HYLIAN */);
    }
    set mirrorShield(bool) {
        this.emulator.rdramWriteBit8(Z64CORE.Z64.Z64_EQUIP_ADDR + 1, 1 /* ShieldBitMap.MIRROR_OOT */, bool);
    }
    get mirrorShield() {
        return this.emulator.rdramReadBit8(Z64CORE.Z64.Z64_EQUIP_ADDR + 1, 1 /* ShieldBitMap.MIRROR_OOT */);
    }
    get shieldLevel() {
        let bits = this.emulator.rdramReadBits8(Z64CORE.Z64.Z64_EQUIP_ADDR);
        if (bits[2 /* ShieldBitMap.MIRROR_MM */] === 0 && bits[3 /* ShieldBitMap.HEROES */] === 1) {
            return 1 /* Z64API.Z64.Shield.HERO */;
        }
        else if (bits[3 /* ShieldBitMap.HEROES */] === 0 && bits[2 /* ShieldBitMap.MIRROR_MM */] === 1) {
            return 2 /* Z64API.Z64.Shield.MIRROR_MM */;
        }
        else {
            return 0 /* Z64API.Z64.Shield.NONE */;
        }
    }
    set shieldLevel(level) {
        let bits = this.emulator.rdramReadBits8(Z64CORE.Z64.Z64_EQUIP_ADDR);
        switch (level) {
            case 0 /* Z64API.Z64.Shield.NONE */:
                bits[3 /* ShieldBitMap.HEROES */] = 0;
                bits[2 /* ShieldBitMap.MIRROR_MM */] = 0;
                break;
            case 1 /* Z64API.Z64.Shield.HERO */:
                bits[3 /* ShieldBitMap.HEROES */] = 1;
                bits[2 /* ShieldBitMap.MIRROR_MM */] = 0;
                break;
            case 2 /* Z64API.Z64.Shield.MIRROR_MM */:
                bits[3 /* ShieldBitMap.HEROES */] = 0;
                bits[2 /* ShieldBitMap.MIRROR_MM */] = 1;
                break;
        }
        this.emulator.rdramWriteBits8(Z64CORE.Z64.Z64_EQUIP_ADDR, bits);
    }
}
exports.ShieldsEquipment = ShieldsEquipment;
//# sourceMappingURL=ShieldsEquipment.js.map