"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KeyManager = void 0;
const Z64API = __importStar(require("../../API/imports"));
const Z64CORE = __importStar(require("../importsZ64"));
class KeyManager {
    KEY_ARRAY_ADDR = Z64CORE.Z64.Z64_SAVE + 0xCA;
    KEY_ARRAY_SIZE = 0x14;
    emulator;
    constructor(emulator) {
        this.emulator = emulator;
    }
    getKeyCountForIndex(index) {
        if (index > this.KEY_ARRAY_ADDR) {
            return Z64API.Z64.NO_KEYS;
        }
        return this.emulator.rdramRead8(this.KEY_ARRAY_ADDR + index);
    }
    setKeyCountByIndex(index, count) {
        if (index > this.KEY_ARRAY_ADDR) {
            return;
        }
        this.emulator.rdramWrite8(this.KEY_ARRAY_ADDR + index, count);
    }
    getRawKeyBuffer() {
        return this.emulator.rdramReadBuffer(this.KEY_ARRAY_ADDR, this.KEY_ARRAY_SIZE);
    }
}
exports.KeyManager = KeyManager;
//# sourceMappingURL=KeyManager.js.map