/// <reference types="node" />
import { JSONTemplate } from "modloader64_api/JSONTemplate";
import IMemory from "modloader64_api/IMemory";
import { ILogger } from "modloader64_api/IModLoaderAPI";
import * as Z64API from '../../API/imports';
import * as Z64CORE from '../importsZ64';
import { IZ64Core } from "@Z64Lib/API/Common/Z64API";
export declare class SaveContext extends JSONTemplate implements Z64API.MM.ISaveContext {
    private emulator;
    save_context: number;
    inventory: Z64CORE.MM.Inventory;
    questStatus: Z64API.MM.IQuestStatus;
    owlStatues: Z64API.MM.IOwlStatues;
    keyManager: Z64API.MM.IKeyManager;
    dungeonItemManager: Z64API.IDungeonItemManager;
    photo: Z64API.MM.IPhoto;
    stray: Z64API.MM.IStray;
    skull: Z64API.MM.ISkull;
    swords: Z64CORE.Z64.SwordsEquipment;
    sword_helper: Z64API.MM.ISwordHelper;
    shields: Z64CORE.Z64.ShieldsEquipment;
    commandBuffer: Z64API.ICommandBuffer;
    magic_meter_size_addr: number;
    magic_fill_cap_addr: number;
    magic_flag_1_addr: number;
    magic_flag_2_addr: number;
    jsonFields: string[];
    constructor(emu: IMemory, log: ILogger, core: IZ64Core);
    get checksum(): number;
    get form(): number;
    get hearts(): number;
    set hearts(flag: number);
    get health_mod(): number;
    set health_mod(flag: number);
    get deku_b_state(): number;
    set deku_b_state(flag: number);
    get razor_hits(): number;
    set razor_hits(flag: number);
    get magic(): number;
    set magic(flag: number);
    get magic_meter_size(): Z64API.Z64.Magic;
    set magic_meter_size(size: Z64API.Z64.Magic);
    get magic_current(): number;
    set magic_current(amount: number);
    get owl_statues(): number;
    set owl_statues(flag: number);
    get map_visible(): Buffer;
    set map_visible(flag: Buffer);
    get map_visited(): Buffer;
    set map_visited(flag: Buffer);
    get tunic_boots(): number;
    set tunic_boots(flag: number);
    get sword_sheild(): number;
    set sword_sheild(flag: number);
    get item_inventory(): Buffer;
    set item_inventory(flag: Buffer);
    get masks(): Buffer;
    set masks(flag: Buffer);
    get item_amts(): Buffer;
    set item_amts(flag: Buffer);
    get upgrades(): number;
    set upgrades(flag: number);
    get questflg1(): number;
    set questflg1(flag: number);
    get questflg2(): number;
    set questflg2(flag: number);
    get questflg3(): number;
    set questflg3(flag: number);
    get questflg4(): number;
    set questflg4_flag(flag: number);
    get double_defense(): number;
    set double_defense(flag: number);
    get permSceneData(): Buffer;
    set permSceneData(flag: Buffer);
    get weekEventFlags(): Buffer;
    set weekEventFlags(buf: Buffer);
    get infTable(): Buffer;
    set infTable(flag: Buffer);
    get minimap_flags(): Buffer;
    set minimap_flags(flag: Buffer);
    get day_time(): number;
    set day_time(flag: number);
    get day_night(): number;
    set day_night(flag: number);
    get time_speed(): number;
    set time_speed(flag: number);
    get current_day(): number;
    set current_day(flag: number);
    get current_transformation(): Z64API.Z64.AgeOrForm;
    set current_transformation(flag: Z64API.Z64.AgeOrForm);
    get intro_flag(): number;
    set intro_flag(flag: number);
    get have_tatl(): number;
    set have_tatl(flag: number);
    get heart_containers(): number;
    set heart_containers(flag: number);
    get rupees(): number;
    set rupees(flag: number);
    get bank(): number;
    set bank(flag: number);
    get lottery_numbers_day1(): Buffer;
    set lottery_numbers_day1(flag: Buffer);
    get lottery_numbers_day2(): Buffer;
    set lottery_numbers_day2(flag: Buffer);
    get lottery_numbers_day3(): Buffer;
    set lottery_numbers_day3(flag: Buffer);
    get spider_house_mask_order(): Buffer;
    set spider_house_mask_order(flag: Buffer);
    get bomber_code(): Buffer;
    set bomber_code(flag: Buffer);
    get pictoboxUsed(): boolean;
    set pictoboxUsed(b: boolean);
    get permFlags(): Buffer;
    set permFlags(b: Buffer);
}
//# sourceMappingURL=SaveContext.d.ts.map