/// <reference types="node" />
import { IRomHeader } from 'modloader64_api/IRomHeader';
import { IModLoaderAPI, ILogger, ICore } from "modloader64_api/IModLoaderAPI";
import * as Z64API from '../API/imports';
import * as Z64CORE from './importsZ64';
import { ROM_REGIONS } from "./Z64Lib";
import { number_ref } from "modloader64_api/Sylvain/ImGui";
export declare class MajorasMask implements ICore, Z64API.MM.IMMCore, Z64API.Z64.IZ64Core {
    header: ROM_REGIONS[];
    ModLoader: IModLoaderAPI;
    eventTicks: Map<string, Function>;
    link: Z64API.Z64.ILink;
    save: Z64API.MM.ISaveContext;
    global: Z64API.MM.IGlobalContext;
    helper: Z64API.MM.IMMHelper;
    commandBuffer: Z64CORE.Z64.CommandBuffer;
    photo: Z64API.MM.IPhoto;
    skull: Z64API.MM.ISkull;
    stray: Z64API.MM.IStray;
    isSaveLoaded: boolean;
    isPaused: boolean;
    last_known_scene: number;
    last_known_room: number;
    doorcheck: boolean;
    touching_loading_zone: boolean;
    frame_count_reset_scene: number;
    last_known_age: number;
    log: ILogger;
    actorManager: Z64API.Z64.IActorManager;
    payloads: string[];
    inventory_cache: Buffer;
    id: number_ref;
    param: number_ref;
    rom_header?: IRomHeader | undefined;
    heap_start: number;
    heap_size: number;
    sceneLockout: boolean;
    preinit(): void;
    onReset1(evt: any): void;
    onReset2(evt: any): void;
    init(): void;
    postinit(): void;
    onTick(): void;
    onViUpdate(): void;
    onPostTick(): void;
    private allZeroBufferCheck;
    onHeapSetup(evt: any): void;
    onHeapReady(evt: any): void;
    toggleMapSelectKeybind(): boolean;
}
//# sourceMappingURL=MajorasMask.d.ts.map