/// <reference types="node" />
import { ICore, IModLoaderAPI } from 'modloader64_api/IModLoaderAPI';
import { IRomHeader } from 'modloader64_api/IRomHeader';
import * as Z64API from '../API/imports';
import * as Z64CORE from './importsZ64';
import { ROM_REGIONS } from './Z64Lib';
import { IActorManager } from '@Z64Lib/API/Common/Z64API';
export interface OOT_Offsets {
    state: number;
    state2: number;
    paused: number;
    raw_anim: number;
    dma_rom: number;
}
export declare class OcarinaofTime implements ICore, Z64API.OoT.IOOTCore, Z64API.Z64.IZ64Core {
    header: ROM_REGIONS[];
    ModLoader: IModLoaderAPI;
    link: Z64API.Z64.ILink;
    save: Z64CORE.OoT.SaveContext;
    global: Z64API.OoT.IGlobalContext;
    helper: Z64API.OoT.IOotHelper;
    commandBuffer: Z64CORE.Z64.CommandBuffer;
    actorManager: IActorManager;
    msgCtx: Z64API.OoT.IMessageContext;
    eventTicks: Map<string, Function>;
    isSaveLoaded: boolean;
    last_known_scene: number;
    last_known_room: number;
    doorcheck: boolean;
    touching_loading_zone: boolean;
    frame_count_reset_scene: number;
    rom_header: IRomHeader;
    inventory_cache: Buffer;
    last_known_age: number;
    map_select_enabled: boolean;
    localFlags: Buffer;
    localFlagsTemp: Buffer;
    localFlagsHash: string;
    permFlagsScene: Buffer;
    permFlagsSceneHash: string;
    heap_start: number;
    heap_size: number;
    isNight: boolean;
    lastHealth: number;
    lastTunic: Z64API.OoT.Tunic;
    preinit(): void;
    onReset1(evt: any): void;
    onReset2(evt: any): void;
    init(): void;
    postinit(): void;
    onTick(frame: number): void;
    onPostTick(): void;
    onInject(evt: any): void;
    private allZeroBufferCheck;
    onHeapSetup(evt: any): void;
    onHeapReady(evt: any): void;
    mapSelectCode(): void;
    toggleMapSelectKeybind(): boolean;
}
//# sourceMappingURL=OcarinaofTime.d.ts.map