/// <reference types="node" />
import { IModLoaderAPI } from "modloader64_api/IModLoaderAPI";
import { Z64LibSupportedGames } from "./Z64LibSupportedGames";
export declare class FilePatch {
    offset: number;
    value: number;
    constructor(offset: number, value: number);
}
export declare class RomPatch {
    finder: string;
    hash: string;
    data: FilePatch[];
    constructor(hash: string);
}
export declare class FileSystemCompare {
    ModLoader: IModLoaderAPI;
    game: Z64LibSupportedGames;
    totalDMAEntries: number;
    ignoreEntries: Array<number>;
    constructor(ModLoader: IModLoaderAPI, game: Z64LibSupportedGames);
    dumpVanilla(rom: Buffer): void;
    dumpDirty(rom: Buffer): void;
    compare(ModLoader: IModLoaderAPI, o?: string): void;
}
//# sourceMappingURL=FileSystemCompare.d.ts.map