/// <reference types="node" />
import { IModLoaderAPI } from 'modloader64_api/IModLoaderAPI';
import { Z64LibSupportedGames } from './Z64LibSupportedGames';
import { RomHeap } from 'modloader64_api/romheap';
export declare class Z64RomTools {
    private ModLoader;
    private DMA_Offset;
    private Particle_Offset;
    private Code_DMA;
    private DMA_DMA;
    private Actor_Offset;
    private Object_Offset;
    constructor(ModLoader: IModLoaderAPI, game: Z64LibSupportedGames);
    static getRomHeap(): RomHeap;
    getCodeFile(rom: Buffer): Buffer;
    isFileCompressed(rom: Buffer, index: number): boolean;
    injectActorIntoSlot(rom: Buffer, actorID: number, file: Buffer, initvars: string): boolean;
    getStartEndOfDMAEntry(rom: Buffer, index: number): {
        vrom_start: number;
        vrom_end: number;
        start: number;
        end: number;
    };
    decompressDMAFileFromRom(rom: Buffer, index: number): Buffer;
    getRawDMAFileFromRom(rom: Buffer, index: number): Buffer;
    recompressDMAFileIntoRom(rom: Buffer, index: number, file: Buffer): boolean;
    findDMAIndexOfParticle(rom: Buffer, index: number): number;
    decompressParticleFileFromRom(rom: Buffer, index: number): Buffer;
    recompressParticleFileIntoRom(rom: Buffer, index: number, file: Buffer): boolean;
    findDMAIndexOfActor(rom: Buffer, index: number): number;
    decompressActorFileFromRom(rom: Buffer, index: number): Buffer;
    recompressActorFileIntoRom(rom: Buffer, index: number, file: Buffer): boolean;
    findDMAIndexOfObject(rom: Buffer, index: number): number;
    decompressObjectFileFromRom(rom: Buffer, index: number): Buffer;
    recompressObjectFileIntoRom(rom: Buffer, index: number, file: Buffer): boolean;
    relocateFileToExtendedRom(rom: Buffer, index: number, file: Buffer, sizeOverride?: number, nocompress?: boolean): number;
    injectNewFile(rom: Buffer, index: number, file: Buffer, nocompress?: boolean): number;
    fixLinkObjectTableEntry(rom: Buffer, code: Buffer, game: Z64LibSupportedGames): Buffer;
    noCRC(rom: Buffer): void;
}
export declare function trimBuffer(buffer: Buffer): Buffer;
//# sourceMappingURL=Z64RomTools.d.ts.map