/// <reference types="node" />
import { JSONTemplate } from 'modloader64_api/JSONTemplate';
import { ILogger, IModLoaderAPI } from 'modloader64_api/IModLoaderAPI';
import * as Z64API from '../../API/imports';
import * as Z64CORE from '../importsZ64';
import { IZ64Core } from '@Z64Lib/API/Common/Z64API';
export declare class SaveContext extends JSONTemplate implements Z64API.OoT.ISaveContext {
    private ModLoader;
    private emulator;
    private instance;
    private entrance_index_addr;
    private age_addr;
    private cutscene_number_addr;
    private world_time_addr;
    private world_night_addr;
    private zeldaz_addr;
    private death_addr;
    private player_name_addr;
    private dd_flag_addr;
    private heart_container_addr;
    private health_addr;
    private magic_meter_size_addr;
    private magic_current_addr;
    private magic_limit_addr;
    private magic_flag_1_addr;
    private magic_flag_2_addr;
    private magic_fill_cap_addr;
    private rupees_address;
    private navi_timer_addr;
    private checksum_addr;
    private magic_beans_addr;
    private poe_score_addr;
    private scene_data_addr;
    private event_data_addr;
    private item_flag_addr;
    private inf_table_addr;
    private skulltula_table_addr;
    private scarecrowsSongChildFlag_addr;
    private scarecrowsSong_addr;
    private scarecrowsSong_addr_1;
    private scarecrowsSong_addr_2;
    private double_defense_addr_1;
    private double_defense_addr_2;
    private index_addr;
    swords: Z64CORE.Z64.SwordsEquipment;
    shields: Z64CORE.Z64.ShieldsEquipment;
    tunics: Z64CORE.OoT.TunicsEquipment;
    boots: Z64CORE.OoT.BootsEquipment;
    inventory: Z64CORE.OoT.Inventory;
    questStatus: Z64API.OoT.IQuestStatus;
    keyManager: Z64API.OoT.IKeyManager;
    dungeonItemManager: Z64API.IDungeonItemManager;
    commandBuffer: Z64API.ICommandBuffer;
    jsonFields: string[];
    constructor(ModLoader: IModLoaderAPI, log: ILogger, core: IZ64Core);
    get entrance_index(): number;
    set entrance_index(index: number);
    get cutscene_number(): number;
    set cutscene_number(index: number);
    get world_time(): number;
    set world_time(time: number);
    get world_night_flag(): boolean;
    set world_night_flag(bool: boolean);
    get zeldaz_string(): string;
    get death_counter(): number;
    set death_counter(deaths: number);
    get player_name(): string;
    set player_name(str: string);
    get dd_flag(): boolean;
    set dd_flag(bool: boolean);
    get heart_containers(): number;
    set heart_containers(num: number);
    get health(): number;
    set health(hearts: number);
    get magic_meter_size(): Z64API.Z64.Magic;
    set magic_meter_size(size: Z64API.Z64.Magic);
    get magic_current(): number;
    set magic_current(amount: number);
    get rupee_count(): number;
    set rupee_count(dosh: number);
    get navi_timer(): number;
    set navi_timer(time: number);
    get checksum(): number;
    get age(): Z64API.Z64.AgeOrForm;
    set age(age: Z64API.Z64.AgeOrForm);
    get magic_beans_purchased(): number;
    set magic_beans_purchased(amt: number);
    get poe_collector_score(): number;
    set poe_collector_score(pts: number);
    get permSceneData(): Buffer;
    set permSceneData(buf: Buffer);
    get eventFlags(): Buffer;
    set eventFlags(buf: Buffer);
    get itemFlags(): Buffer;
    set itemFlags(buf: Buffer);
    get infTable(): Buffer;
    set infTable(buf: Buffer);
    get skulltulaFlags(): Buffer;
    set skulltulaFlags(buf: Buffer);
    get scarecrowsSongChildFlag(): boolean;
    set scarecrowsSongChildFlag(bool: boolean);
    get scarecrowsSong(): Buffer;
    set scarecrowsSong(buf: Buffer);
    get double_defense(): number;
    set double_defense(n: number);
    get bButton(): number;
    get index(): number;
}
//# sourceMappingURL=SaveContext.d.ts.map