/// <reference types="node" />
import { IModLoaderAPI } from 'modloader64_api/IModLoaderAPI';
import { PayloadType } from 'modloader64_api/PayloadType';
import IMemory from 'modloader64_api/IMemory';
import * as Z64API from '../API/imports';
import Vector3 from 'modloader64_api/math/Vector3';
export declare class OvlPayloadResult implements Z64API.Z64.IOvlPayloadResult {
    slot: number;
    core: Z64API.Z64.IZ64Core;
    size: number;
    pointer: number;
    constructor(core: Z64API.Z64.IZ64Core, slot: number, pointer: number, size: number);
    spawnActorRXYZ(params: number, rotX: number, rotY: number, rotZ: number, pos: Vector3, address?: number): Promise<Z64API.IActor>;
    spawnActorRXY_Z(params: number, rotXY: number, rotZ: number, pos: Vector3, address?: number): Promise<Z64API.IActor>;
    spawn(params: number, rot: Vector3, pos: Vector3, address?: number): Promise<Z64API.IActor>;
}
export declare class find_init {
    constructor();
    find(buf: Buffer, locate: string): number;
}
export interface ovl_meta {
    init: string;
    forceSlot: string;
}
export declare class OverlayPayload extends PayloadType {
    private ModLoader;
    private core;
    constructor(ext: string, ModLoader: IModLoaderAPI, core: Z64API.Z64.IZ64Core);
    parse(file: string, buf: Buffer, dest: IMemory): -1 | OvlPayloadResult;
}
//# sourceMappingURL=OverlayPayload.d.ts.map