import { IRomHeader } from 'modloader64_api/IRomHeader';
import { IModLoaderAPI, ICore, IExtendedCore } from "modloader64_api/IModLoaderAPI";
import { MajorasMask } from "./MajorasMask";
import { OcarinaofTime } from "./OcarinaofTime";
import { IZ64Main } from '../API/Common/IZ64Main';
export declare enum ROM_VERSIONS {
    N0 = 0,
    GAMECUBE = 15,
    REV_A = 1,
    REV_B = 2
}
export declare enum ROM_REGIONS {
    DEBUG_OOT = "NZL",
    NTSC_OOT = "CZL",
    NTSC_MM = "NZS"
}
export default class Z64Lib implements ICore, IZ64Main, IExtendedCore {
    header: ROM_REGIONS[];
    ModLoader: IModLoaderAPI;
    eventTicks: Map<string, Function>;
    OOT: OcarinaofTime | undefined;
    MM: MajorasMask | undefined;
    rom_header: IRomHeader;
    get heap_size(): number;
    get heap_start(): number;
    postconstructor(): void;
    applyVersionPatch(msg: string, bps: string, target: ROM_VERSIONS): void;
    preinit(): void;
    init(): void;
    postinit(): void;
    onTick(): void;
}
//# sourceMappingURL=Z64Lib.d.ts.map